automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: bug#8846: coreutils-8.12 on HP-UX 11.31: 3 of 365 tests failed


From: Stefano Lattarini
Subject: Re: bug#8846: coreutils-8.12 on HP-UX 11.31: 3 of 365 tests failed
Date: Tue, 14 Jun 2011 09:47:32 +0200
User-agent: KMail/1.13.3 (Linux/2.6.30-2-686; KDE/4.4.4; i686; ; )

[adding automake-patches on CC:]

Reference to original thread(s), mostly duplicated:
 <http://lists.gnu.org/archive/html/bug-coreutils/2011-06/msg00051.html>
 <http://lists.gnu.org/archive/html/bug-autoconf/2011-06/msg00002.html>

Reference to last relevant message there:
 <http://lists.gnu.org/archive/html/bug-autoconf/2011-06/msg00018.html>
 <http://lists.gnu.org/archive/html/bug-coreutils/2011-06/msg00082.html>
 
On Tuesday 14 June 2011, Eric Blake wrote:
> On 06/13/2011 04:29 PM, Stefano Lattarini wrote:
> > If this work, then using a bare `>&2' *at the end of TESTS_ENVIRONMENT* and
> 
> You meant a bare `9>&2',
>
Yes, sorry.

> but yes that does seem to be workable for what we want!
> 
> > *without a following semicolon* might give a portable workaround, as if I'm
> > not mistaken POSIX mandates that redirections can be specified anywere on
> > the command line, and are to be evaluated from left to right.
> 
> Yes, all shells support these as equivalent:
> 
> 9>&2 sh k
> sh k 9>&2
> 
> > 
> > UPDATE: Yes, it seems to work.  I'll add a testcase to the 'maint' branch in
> > case you and Jim decide to go with this solution (and you can confirm that 
> > it
> > really works).
> 
> Cool!  Definitely worth documenting in the automake manual, as owner of
> TESTS_ENVIRONMENT and as a client of init.sh functionality, as well as
> your proposed automake testcase addition to ensure we don't break it.
> 
 
I'll then push the attached patch to automake master soonish (by tomorrow
or so) if there is no objection by then.

Regards,
  Stefano
From 9f80020a24110e599b7dbdc5699dc8dbf5af0bd2 Mon Sep 17 00:00:00 2001
Message-Id: <address@hidden>
From: Stefano Lattarini <address@hidden>
Date: Tue, 14 Jun 2011 09:41:14 +0200
Subject: [PATCH] tests: check portable fd redirection in TESTS_ENVIRONMENT

* tests/tests-environment-fd-redirect.test: New test.
* tests/Makefile.am (TESTS): Update.

Motivated by coreutils bug#8846:
 <http://debbugs.gnu.org/cgi/bugreport.cgi?bug=8846>
See also following CC:ed thread on bug-autoconf list:
 <http://lists.gnu.org/archive/html/bug-autoconf/2011-06/msg00002.html>
---
 ChangeLog                                |   10 ++++
 tests/Makefile.am                        |    1 +
 tests/Makefile.in                        |    1 +
 tests/tests-environment-fd-redirect.test |   75 ++++++++++++++++++++++++++++++
 4 files changed, 87 insertions(+), 0 deletions(-)
 create mode 100755 tests/tests-environment-fd-redirect.test

diff --git a/ChangeLog b/ChangeLog
index aad41c7..e482cbd 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,13 @@
+2011-06-14  Stefano Lattarini  <address@hidden>
+
+       tests: check portable fd redirection in TESTS_ENVIRONMENT
+       * tests/tests-environment-fd-redirect.test: New test.
+       * tests/Makefile.am (TESTS): Update.
+       Motivated by coreutils bug#8846:
+        <http://debbugs.gnu.org/cgi/bugreport.cgi?bug=8846>
+       See also following CC:ed thread on bug-autoconf list:
+        <http://lists.gnu.org/archive/html/bug-autoconf/2011-06/msg00002.html>
+
 2011-06-08  Stefano Lattarini  <address@hidden>
 
        test defs: new function 'fatal_', for hard errors
diff --git a/tests/Makefile.am b/tests/Makefile.am
index e68f6d7..c0f39ce 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -949,6 +949,7 @@ tar2.test \
 tar3.test \
 target-cflags.test \
 targetclash.test \
+tests-environment-fd-redirect.test \
 txinfo.test \
 txinfo2.test \
 txinfo3.test \
diff --git a/tests/Makefile.in b/tests/Makefile.in
index 7e5fd09..4c223fc 100644
--- a/tests/Makefile.in
+++ b/tests/Makefile.in
@@ -1216,6 +1216,7 @@ tar2.test \
 tar3.test \
 target-cflags.test \
 targetclash.test \
+tests-environment-fd-redirect.test \
 txinfo.test \
 txinfo2.test \
 txinfo3.test \
diff --git a/tests/tests-environment-fd-redirect.test 
b/tests/tests-environment-fd-redirect.test
new file mode 100755
index 0000000..2a0afa9
--- /dev/null
+++ b/tests/tests-environment-fd-redirect.test
@@ -0,0 +1,75 @@
+#! /bin/sh
+# Copyright (C) 2011 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Test for a behaviour of `TESTS_ENVIRONMENT' and `AM_TESTS_ENVIRONMENT'
+# w.r.t. file descriptor redirections which, although undocumented,
+# is nonetheless required by Gnulib's 'tests/init.sh' and by coreutils'
+# testsuite.
+# The checked behaviour is that we can portably do file descriptor
+# redirections by placing them at the end of a {AM_,}TESTS_ENVIRONMENT
+# definition without a following semicolon.  The need to support this
+# is detailedly motivated by coreutils bug#8846:
+#   <http://debbugs.gnu.org/cgi/bugreport.cgi?bug=8846>
+# and the following CC:ed thread on bug-autoconf list:
+#   <http://lists.gnu.org/archive/html/bug-autoconf/2011-06/msg00002.html>
+
+parallel_tests=yes
+. ./defs || Exit 1
+
+cat >> configure.in << 'END'
+AC_OUTPUT
+END
+
+cat >foo.test <<'END'
+#! /bin/sh
+echo " " $0: foofoofoo >&8
+echo " " $0: barbarbar >&9
+END
+chmod a+x foo.test
+
+$ACLOCAL
+$AUTOCONF
+
+# /bin/ksh seems more vulnerable to the issue highlighted in coreutils
+# bug#8846 than other shells are.  In particular, the default Korn Shell
+# on Debian GNU/Linux is affected by the issue.  So let's try to run our
+# test with /bin/ksh too, if that's available.
+if test "$SHELL" != /bin/ksh && test -f /bin/ksh; then
+  bin_ksh=/bin/ksh
+else
+  bin_ksh=:
+fi
+
+for sh in "$SHELL" "$bin_ksh"; do
+  test "$sh" = : && continue
+  for pfx in AM_ ''; do 
+    unindent > Makefile.am <<END
+      TESTS = foo.test
+      ## No trailing semicolon here, *deliberately*.
+      ${pfx}TESTS_ENVIRONMENT = 8>&1 9>&8
+END
+    $AUTOMAKE -a
+    CONFIG_SHELL="$sh" $sh ./configure CONFIG_SHELL="$sh"
+    $MAKE check >stdout || { cat stdout; Exit 1; }
+    cat stdout
+    grep '[ /]foo\.test: foofoofoo$' stdout
+    grep '[ /]foo\.test: barbarbar$' stdout
+    $EGREP '(foofoofoo|barbarbar)' foo.log && Exit 1
+    : # For shells with buggy 'set -e'.
+  done
+done
+
+:
-- 
1.7.2.3


reply via email to

[Prev in Thread] Current Thread [Next in Thread]